/*
	Maintain a history of applied updates to the database.
*/

if not exists (select 'x' from information_schema.tables where table_name = 'version_history')
create table version_history
(
	VersionNumber nvarchar(100) not null,
	DateApplied datetime not null default GETUTCDATE()
)
go

if not exists (select 'x' from sys.indexes where name = 'pk_version_history')
alter table version_history add constraint pk_version_history primary key (VersionNumber, DateApplied)
go

insert into version_history (VersionNumber) values (N'9.2.0.108.0.108')
